exec("./Profiles.cs");
exec("./AchGUI.gui");

if(!$Ach::Loaded) {
   $Ach::Gui::X = 2;
   $Ach::Gui::Y = 2;
   $Ach::Loaded = true;
   
   $remapDivision[$remapCount] = "Achievements";
	$remapName[$remapCount] = "Open Achievements";
	$remapCmd[$remapCount] = "openAchGUI";
	$remapCount++;
}

function openAchGUI()
{
   canvas.pushDialog(AchGUI);
}

function clientCmdAddAch(%bitmapImage, %name, %text)
{
   if(%name $= "" || %text $= "" || !$Ach::Loaded)
      return;
      
   if(!isFile($Ach::Icons[%bitmapImage]))
      %bitmapImage = "Add-Ons/Script_achievements/images/unknown.png";
      
   $Ach::Bitmap::Locked[%name] = new GuiBitmapCtrl() {
                        profile = "GuiDefaultProfile";
                        horizSizing = "right";
                        vertSizing = "bottom";
                        position = $Ach::Gui::X SPC $Ach::Gui::Y;
                        extent = "719 72";
                        minExtent = "8 2";
                        visible = "1";
                        wrap = "1";
                        lockAspectRatio = "0";
                        alignLeft = "0";
                        overflowImage = "0";
                        keepCached = "0";
                        bitmap = "Add-Ons/Script_achievements/images/background.png";
                        
                        new GuiTextCtrl() {
                        profile = "ACHTopLockedProfile";
                        horizSizing = "right";
                        vertSizing = "bottom";
                        position = "104 4";
                        extent = "519 26";
                        minExtent = "8 2";
                        visible = "1";
                        text = "\c3" @ %name;
                        maxLength = "255";
                     };
                     new GuiTextCtrl() {
                        profile = "ACHBottomlockedProfile";
                        horizSizing = "right";
                        vertSizing = "bottom";
                        position = "104 24";
                        extent = "519 26";
                        minExtent = "8 2";
                        visible = "1";
                        text = "\c3" @ %text;
                        maxLength = "255";
                     };
                     new GuiBitmapCtrl() {
                        profile = "GuiDefaultProfile";
                        horizSizing = "right";
                        vertSizing = "bottom";
                        position = "3 3";
                        extent = "66 66";
                        minExtent = "8 2";
                        visible = "1";
                        bitmap = $Ach::Icons[%bitmapImage];
                        wrap = "1";
                        lockAspectRatio = "0";
                        alignLeft = "0";
                        overflowImage = "0";
                        keepCached = "0";
                     };
                  };
                  
  ACHSWATCH.add($Ach::Bitmap::Locked[%name]);
  
  
                       $Ach::Bitmap::Unlocked[%name] = new GuiSwatchCtrl() {
                        profile = "GuiDefaultProfile";
                        horizSizing = "right";
                        vertSizing = "bottom";
                        position = "2 2";
                        extent = "738 73";
                        minExtent = "8 2";
                        visible = "1";
                        color = "59 91 156 144";
                     };
  $Ach::Bitmap::Locked[%name].add($Ach::Bitmap::Unlocked[%name]);
  
  %ex = getWord(ACHSWATCH.extent, 1);
  ACHSWATCH.resize(1, 1, 738, %ex+76);
  $Ach::Gui::Y = $Ach::Gui::Y + 76;
}

function registerAchievementIcon(%path, %name)
{
   if(%name $= "" || $Ach::Icons[%name] !$= "")
      return;
      
   if(!isFile(%path))
      %path = "Add-Ons/Script_achievements/images/unknown.png";
   
   $Ach::Icons[%name] = %path;
}

function clientCmdRegisterAchievementIcon(%path, %name)
{
   if(%name $= "" || $Ach::Icons[%name] !$= "")
      return;
      
   if(!isFile(%path))
      %path = "Add-Ons/Script_achievements/images/unknown.png";
   
   $Ach::Icons[%name] = %path;
}

function clientCmdUnlockAch(%name)
{
   if(%name $= "")
   return;   
   
   // Now check it, because it was returning weird errors before.
   if(isObject($Ach::Bitmap::Unlocked[%name]))
      $Ach::Bitmap::Unlocked[%name].delete();
}

function clientCmdclearAch()
{
   ACHSWATCH.clear();
   ACHSWATCH.resize(1, 1, 738, 1);
   $Ach::Gui::X = 2;
   $Ach::Gui::Y = 2;
}

function clientCmdIHaveAchievementsMod()
{
   commandtoserver('IHaveAchievementsMod');
}

// Now register the icons.
registerAchievementIcon("Add-Ons/Script_achievements/images/....png", "...");
registerAchievementIcon("Add-Ons/Script_achievements/images/crap.png", "crap");
registerAchievementIcon("Add-Ons/Script_achievements/images/eye.png", "eye");
registerAchievementIcon("Add-Ons/Script_achievements/images/money_sign.png", "moneysign");
registerAchievementIcon("Add-Ons/Script_achievements/images/pedo.png", "pedo");
registerAchievementIcon("Add-Ons/Script_achievements/images/banana.png", "banana");
registerAchievementIcon("Add-Ons/Script_achievements/images/blablabla.png", "blablabla");
registerAchievementIcon("Add-Ons/Script_achievements/images/bsod.png", "bsod");
registerAchievementIcon("Add-Ons/Script_achievements/images/censored.png", "censored");
registerAchievementIcon("Add-Ons/Script_achievements/images/dice.png", "dice");
registerAchievementIcon("Add-Ons/Script_achievements/images/fail.png", "fail");
registerAchievementIcon("Add-Ons/Script_achievements/images/heart.png", "heart");
registerAchievementIcon("Add-Ons/Script_achievements/images/lol.png", "lol");
registerAchievementIcon("Add-Ons/Script_achievements/images/mac.png", "mac");
registerAchievementIcon("Add-Ons/Script_achievements/images/middlefinger.png", "middlefinger");
registerAchievementIcon("Add-Ons/Script_achievements/images/mouse.png", "mouse");
registerAchievementIcon("Add-Ons/Script_achievements/images/mw.png", "mw");
registerAchievementIcon("Add-Ons/Script_achievements/images/number1.png", "number1");
registerAchievementIcon("Add-Ons/Script_achievements/images/pa.png", "pa");
registerAchievementIcon("Add-Ons/Script_achievements/images/pacman.png", "pacman");
registerAchievementIcon("Add-Ons/Script_achievements/images/pwned.png", "pwned");
registerAchievementIcon("Add-Ons/Script_achievements/images/stop.png", "stop");
registerAchievementIcon("Add-Ons/Script_achievements/images/target.png", "target");
registerAchievementIcon("Add-Ons/Script_achievements/images/trans.png", "trans");
registerAchievementIcon("Add-Ons/Script_achievements/images/trash.png", "trash");
registerAchievementIcon("Add-Ons/Script_achievements/images/unknown.png", "unknown");
registerAchievementIcon("Add-Ons/Script_achievements/images/void.png", "void");
registerAchievementIcon("Add-Ons/Script_achievements/images/weirdface.png", "weirdface");
registerAchievementIcon("Add-Ons/Script_achievements/images/hugger.png", "hugger");
registerAchievementIcon("Add-Ons/Script_achievements/images/GunSpam.png", "gunspam");
registerAchievementIcon("Add-Ons/Script_achievements/images/windows.png", "windows");
registerAchievementIcon("Add-Ons/Script_achievements/images/nuke.png", "nuke");
registerAchievementIcon("Add-Ons/Script_achievements/images/health.png", "health");
registerAchievementIcon("Add-Ons/Script_achievements/images/blockland.png", "blockland");
registerAchievementIcon("Add-Ons/Script_achievements/images/lego.png", "lego");
registerAchievementIcon("Add-Ons/Script_achievements/images/arrows.png", "arrows");

// User based packs.
registerAchievementIcon("Add-Ons/Script_achievements/images/Regulith/eventer.png", "eventer");
registerAchievementIcon("Add-Ons/Script_achievements/images/Regulith/hammer.png", "hammer");